# Chapter 4. Expressions

* C++ provides set of operators
  * Also define what these operators do when applied to built-type operand
* **Expression** consists of single/multi operands. When evaluated, it yields a result

## 4.1 Fundamentals

## 4.2 Arithmetic Operators

## 4.3 Logical and Relational Operators

## 4.4 Assignment Operators

## 4.5 Increment and Decrement Operators

## 4.6 The Member Access Operators

* `.` & `->` operators provide member access.
  * `.` get member from an object of class type
  * `->` dereference then get member; `ptr->mem` is synonum for `(*ptr).mem`
* `.` has higher precedence than dereference (i.e. ->)

```cpp
// run the size member of p, then dereference the result!
*p.size();    // error: p is a pointer and has no member named size
```

## 4.7 The Conditional Operator

## 4.8 The Bitwise Operators

## 4.9 The sizeof Operator

* **sizeof** operator returns size (in bytes) of **an expression** or **a type name**.
* It's right associative
* Result of `sizeof` is a constant expression of type `size_t`
* Syntax of `sizeof`:
  * For type name: `sizeof (type)`
  * For expression: `sizeof expr`
* `sizeof` doesn't evaluate its operand

```cpp
Sales_data data, *p;
sizeof(Sales_data); // size required to hold an object of type Sales_data
sizeof data; // size of data's type, i.e., sizeof(Sales_data)
sizeof p;    // size of a pointer
sizeof *p;   // size of the type to which p points, i.e., sizeof(Sales_data)
sizeof data.revenue; // size of the type of Sales_data's revenue member
sizeof Sales_data::revenue; // alternative way to get the size of revenue
```


## 4.10 Comma Operator

## 4.11 Type Conversions

## 4.12 Operator Precedence Table